

# UpdateCapability
<a name="API_UpdateCapability"></a>

Updates the configuration of a managed capability in your Amazon EKS cluster. You can update the IAM role, configuration settings, and delete propagation policy for a capability.

When you update a capability, Amazon EKS applies the changes and may restart capability components as needed. The capability remains available during the update process, but some operations may be temporarily unavailable.

## Request Syntax
<a name="API_UpdateCapability_RequestSyntax"></a>

```
POST /clusters/name/capabilities/capabilityName HTTP/1.1
Content-type: application/json

{
   "clientRequestToken": "string",
   "configuration": { 
      "argoCd": { 
         "networkAccess": { 
            "vpceIds": [ "string" ]
         },
         "rbacRoleMappings": { 
            "addOrUpdateRoleMappings": [ 
               { 
                  "identities": [ 
                     { 
                        "id": "string",
                        "type": "string"
                     }
                  ],
                  "role": "string"
               }
            ],
            "removeRoleMappings": [ 
               { 
                  "identities": [ 
                     { 
                        "id": "string",
                        "type": "string"
                     }
                  ],
                  "role": "string"
               }
            ]
         }
      }
   },
   "deletePropagationPolicy": "string",
   "roleArn": "string"
}
```

## URI Request Parameters
<a name="API_UpdateCapability_RequestParameters"></a>

The request uses the following URI parameters.

 ** [capabilityName](#API_UpdateCapability_RequestSyntax) **   <a name="AmazonEKS-UpdateCapability-request-uri-capabilityName"></a>
The name of the capability to update configuration for.  
Required: Yes

 ** [name](#API_UpdateCapability_RequestSyntax) **   <a name="AmazonEKS-UpdateCapability-request-uri-clusterName"></a>
The name of the Amazon EKS cluster that contains the capability you want to update configuration for.  
Required: Yes

## Request Body
<a name="API_UpdateCapability_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [clientRequestToken](#API_UpdateCapability_RequestSyntax) **   <a name="AmazonEKS-UpdateCapability-request-clientRequestToken"></a>
A unique, case-sensitive identifier that you provide to ensure the idempotency of the request. This token is valid for 24 hours after creation.  
Type: String  
Required: No

 ** [configuration](#API_UpdateCapability_RequestSyntax) **   <a name="AmazonEKS-UpdateCapability-request-configuration"></a>
The updated configuration settings for the capability. You only need to specify the configuration parameters you want to change. For Argo CD capabilities, you can update RBAC role mappings and network access settings.  
Type: [UpdateCapabilityConfiguration](API_UpdateCapabilityConfiguration.md) object  
Required: No

 ** [deletePropagationPolicy](#API_UpdateCapability_RequestSyntax) **   <a name="AmazonEKS-UpdateCapability-request-deletePropagationPolicy"></a>
The updated delete propagation policy for the capability. Currently, the only supported value is `RETAIN`.  
Type: String  
Valid Values: `RETAIN`   
Required: No

 ** [roleArn](#API_UpdateCapability_RequestSyntax) **   <a name="AmazonEKS-UpdateCapability-request-roleArn"></a>
The Amazon Resource Name (ARN) of the IAM role that the capability uses to interact with Amazon services. If you specify a new role ARN, the capability will start using the new role for all subsequent operations.  
Type: String  
Required: No

## Response Syntax
<a name="API_UpdateCapability_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "update": { 
      "createdAt": number,
      "errors": [ 
         { 
            "errorCode": "string",
            "errorMessage": "string",
            "resourceIds": [ "string" ]
         }
      ],
      "id": "string",
      "params": [ 
         { 
            "type": "string",
            "value": "string"
         }
      ],
      "status": "string",
      "type": "string"
   }
}
```

## Response Elements
<a name="API_UpdateCapability_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [update](#API_UpdateCapability_ResponseSyntax) **   <a name="AmazonEKS-UpdateCapability-response-update"></a>
An object representing an asynchronous update.  
Type: [Update](API_Update.md) object

## Errors
<a name="API_UpdateCapability_Errors"></a>

For information about the errors that are common to all actions, see [Common Errors](CommonErrors.md).

 ** AccessDeniedException **   
You don't have permissions to perform the requested operation. The [IAM principal](https://docs.amazonaws.cn/IAM/latest/UserGuide/id_roles_terms-and-concepts.html) making the request must have at least one IAM permissions policy attached that grants the required permissions. For more information, see [Access management](https://docs.amazonaws.cn/IAM/latest/UserGuide/access.html) in the *IAM User Guide*.     
 ** message **   
You do not have sufficient access to perform this action.
HTTP Status Code: 403

 ** InvalidParameterException **   
The specified parameter is invalid. Review the available parameters for the API request.    
 ** addonName **   
The specified parameter for the add-on name is invalid. Review the available parameters for the API request  
 ** clusterName **   
The Amazon EKS cluster associated with the exception.  
 ** fargateProfileName **   
The Fargate profile associated with the exception.  
 ** message **   
The specified parameter is invalid. Review the available parameters for the API request.  
 ** nodegroupName **   
The Amazon EKS managed node group associated with the exception.  
 ** subscriptionId **   
The Amazon EKS subscription ID with the exception.
HTTP Status Code: 400

 ** ResourceInUseException **   
The specified resource is in use.    
 ** addonName **   
The specified add-on name is in use.  
 ** clusterName **   
The Amazon EKS cluster associated with the exception.  
 ** message **   
The Amazon EKS message associated with the exception.  
 ** nodegroupName **   
The Amazon EKS managed node group associated with the exception.
HTTP Status Code: 409

 ** ResourceNotFoundException **   
The specified resource could not be found. You can view your available clusters with `ListClusters`. You can view your available managed node groups with `ListNodegroups`. Amazon EKS clusters and node groups are Amazon Web Services Region specific.    
 ** addonName **   
The Amazon EKS add-on name associated with the exception.  
 ** clusterName **   
The Amazon EKS cluster associated with the exception.  
 ** fargateProfileName **   
The Fargate profile associated with the exception.  
 ** message **   
The Amazon EKS message associated with the exception.  
 ** nodegroupName **   
The Amazon EKS managed node group associated with the exception.  
 ** subscriptionId **   
The Amazon EKS subscription ID with the exception.
HTTP Status Code: 404

 ** ServerException **   
These errors are usually caused by a server-side issue.    
 ** addonName **   
The Amazon EKS add-on name associated with the exception.  
 ** clusterName **   
The Amazon EKS cluster associated with the exception.  
 ** message **   
These errors are usually caused by a server-side issue.  
 ** nodegroupName **   
The Amazon EKS managed node group associated with the exception.  
 ** subscriptionId **   
The Amazon EKS subscription ID with the exception.
HTTP Status Code: 500

## See Also
<a name="API_UpdateCapability_SeeAlso"></a>

For more information about using this API in one of the language-specific Amazon SDKs, see the following:
+  [Amazon Command Line Interface V2](https://docs.amazonaws.cn/goto/cli2/eks-2017-11-01/UpdateCapability) 
+  [Amazon SDK for .NET V4](https://docs.amazonaws.cn/goto/DotNetSDKV4/eks-2017-11-01/UpdateCapability) 
+  [Amazon SDK for C\$1\$1](https://docs.amazonaws.cn/goto/SdkForCpp/eks-2017-11-01/UpdateCapability) 
+  [Amazon SDK for Go v2](https://docs.amazonaws.cn/goto/SdkForGoV2/eks-2017-11-01/UpdateCapability) 
+  [Amazon SDK for Java V2](https://docs.amazonaws.cn/goto/SdkForJavaV2/eks-2017-11-01/UpdateCapability) 
+  [Amazon SDK for JavaScript V3](https://docs.amazonaws.cn/goto/SdkForJavaScriptV3/eks-2017-11-01/UpdateCapability) 
+  [Amazon SDK for Kotlin](https://docs.amazonaws.cn/goto/SdkForKotlin/eks-2017-11-01/UpdateCapability) 
+  [Amazon SDK for PHP V3](https://docs.amazonaws.cn/goto/SdkForPHPV3/eks-2017-11-01/UpdateCapability) 
+  [Amazon SDK for Python](https://docs.amazonaws.cn/goto/boto3/eks-2017-11-01/UpdateCapability) 
+  [Amazon SDK for Ruby V3](https://docs.amazonaws.cn/goto/SdkForRubyV3/eks-2017-11-01/UpdateCapability) 